program qq;
  uses crt,graph;
  const eps=0.001;
        pouse=5000;
  var x0,y0,xf,yf,x1,x2,x3,y1,y2,y3,xa,ya,fa,bx,by:real;
      p,q,c,aa,bb,cc,dd,dfi:real;
      tx0,ty0,txf,tyf,tx1,tx2,tx3,ty1,ty2,ty3:integer;
      gd,gm,yy,xx:integer;
      path:string;
      ch:char;

procedure x_to_tx(x,y:real;var tx,ty:integer);
  begin
    tx:=trunc(x*230)+320;
    ty:=-trunc(y*230)+240;
  end;

procedure systemsolve(p,q,c:real;var x1,y1,x2,y2:real);
  begin
    if p=0
      then
        begin
          x1:=sqrt(abs(c*c/q/q-1));
          x2:=-x1;
          y1:=(c-p*x1)/q;
          y2:=(c-p*x2)/q
        end
      else
        begin
          if q=0
            then
              begin
                x1:=c/p;
                x2:=x1;
                y1:=sqrt(abs(1-x1*x1));
                y2:=-y1
              end
            else
              begin
                aa:=1+p*p/q/q;
                bb:=-2*c*p/q/q;
                cc:=c*c/q/q-1;
                dd:=bb*bb-4*aa*cc;
                x1:=(-bb-sqrt(dd))/2/aa;
                x2:=(-bb+sqrt(dd))/2/aa;
                y1:=(c-p*x1)/q;
                y2:=(c-p*x2)/q
              end
        end
  end;

procedure triangle(fa:real;ccc:integer);
  begin
    xa:=cos(fa); ya:=sin(fa);
    bx:=(xf+xa)/2; by:=(yf+ya)/2;
    p:=xf-xa; q:=yf-ya;
    c:=p*bx+q*by;{ࠢ אַ px+qy=c}
    systemsolve(p,q,c,x1,y1,x2,y2);
    x_to_tx(x1,y1,tx1,ty1);
    x_to_tx(x2,y2,tx2,ty2);
    Setcolor(ccc);
    line(tx1,ty1,tx2,ty2);
    c:=-q*bx+p*by;
    systemsolve(-q,p,c,x1,y1,x2,y2);
    if (abs(xa-x1)<eps) and (abs(ya-y1)<eps)
      then
        begin
          x3:=x2;
          y3:=y2
        end
      else
        begin
          x3:=x1;
          y3:=y1
        end;
    x_to_tx(x3,y3,tx3,ty3);
    line(tx1,ty1,tx3,ty3);
    line(tx2,ty2,tx3,ty3);
    fa:=fa+dfi
  end;

begin
  x0:=0;y0:=0;
  xf:=0.95; yf:=0; {focus}
  TextBackground(1);
  TextColor(11);
  Clrscr;
  Writeln('Enter the abscissa of the focus (from -0.999 to +0.999)');
  read(xf);
  path:='c:/tp/bgi';
  gd:=detect;
  gm:=0;
  initgraph(gd,gm,path);
  SetBKColor(1);
  cleardevice;
  x_to_tx(x0,y0,tx0,ty0);
  x_to_tx(xf,yf,txf,tyf);
  circle(tx0,ty0,230);
  putpixel(tx0,ty0,4);
  putpixel(txf,tyf,14);
  dfi:=0.01;
  fa:=0;
  xx:=(tx0+txf) div 2;
  yy:=(ty0+tyf) div 2;
  repeat
    triangle(fa,15);
    delay(pouse);
    triangle(fa,0);
    setcolor(14);
    ellipse(xx,yy,0,360,115,trunc(114*sqrt(1-xf*xf)));
    setcolor(15);
    circle(tx0,ty0,230);
    Setcolor(2);
    circle(xx,yy,114);
    fa:=fa+dfi;
    if fa>20*pi then fa:=0
  until keypressed;
  triangle(fa,4);
  triangle(fa+2*pi/5,13);
  triangle(fa-2*pi/5,9);
  {Euler's circle:}
  Setcolor(2);
  circle(xx,yy,114);
  setcolor(14);
  ellipse(xx,yy,0,360,115,trunc(114*sqrt(1-xf*xf)));
  outtextxy(0,0,'esc');
  if (abs(xf)>=0.07)and(abs(xf)<=0.93)
    then
      begin
        outtextxy(315,245,'F1');
        outtextxy(txf-5,245,'F2');
      end;
  repeat
    ch:=readkey;
  until ord(ch)=27;
  cleardevice;
  closegraph;
end.
